<?php

/*
This file is part of the inventory module, written by Franky Van Liedekerke for
more.groupware
Contact: liedekef@pandora.be
                                                                                
The inventory module is distributed under the terms of the GNU General Public License
                                                                                
The inventory module is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
The inventory module is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this module; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class inv_Location {
    var $locationid = 0;
    var $locationtitle = "";
    var $description = "";
    var $preference = 0;

    /*
     constructor
    */
    function inv_Location() {
        $arguments = func_get_args();
	switch(func_num_args()) {
		case 0:
			//nothing to do
			$this->locationid=0;
			break;
		case 1:
			$this->locationid=(int)$arguments[0];
			break;
	}
	$this->load();
    }

    function load() {
        global $conn;
        $vars=array('locationtitle','description','preference');
	$sql="SELECT * FROM mgw_inventory_locations WHERE locationid=".$this->locationid;
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	if ($row = $res->FetchRow()) {
            foreach ($vars as $value) {
                $this->$value=$row[$value];
            }
	}
    }

    function save() {
        global $conn;
        $vars=array('locationid','locationtitle','description','preference');

	// insert the info for the catgory itself
        foreach ($vars as $value) {
            $$value=$conn->QMagic($this->$value);
        }
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_locations WHERE locationid = $locationid");
        if ($count >0) {
           $sql="UPDATE mgw_inventory_locations SET locationtitle=$locationtitle,description=$description,preference=$preference WHERE locationid=$locationid";
        } else {
           $sql="INSERT INTO mgw_inventory_locations (locationid,locationtitle,description,preference)
             VALUES ($locationid,$locationtitle,$description,$preference)";
        }
        if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function modify_location($mode) {
        global $smarty;
        $vars=array('locationid','locationtitle','description','preference');

	if ($mode == "newloc") {
	   $this->locationid=mgw_genID('mgw__seq_inventory_category');
	}
        foreach ($vars as $value) {
            $smarty->assign($value,$this->$value);
        }
	$smarty->assign("mode","$mode");
	$smarty->assign("submitname","$mode");
	if ($mode == "newloc")
	   $smarty->assign("submitvalue",Lang::getLanguageString("new"));
	if ($mode == "editloc")
	   $smarty->assign("submitvalue",Lang::getLanguageString("edit"));
	if ($mode == "delloc")
	   $smarty->assign("submitvalue",Lang::getLanguageString("delete"));
	if ($mode == "viewloc")
	   $smarty->assign("submitvalue",Lang::getLanguageString("return"));

	if ($mode == "newloc" || $mode == "editloc") {
	    $smarty->display('inventory_admin_location_modify.tpl');
	} else {
	    $smarty->display('inventory_admin_location_view.tpl');
	}
    }

    function admin_locs() {
	global $smarty;
	$smarty->assign("locationlist",inventory_locationlist());
	$smarty->display('inventory_admin_location_list.tpl');
    }

    function viewlocations() {
	global $smarty;
	$smarty->assign("locationlist",inventory_locationlist());
	$smarty->display('inventory_location_list.tpl');
    }

    function admin_updatepreference() {
	global $conn;
	foreach ($_POST["preference"] as $key => $val) {
	    $sql="UPDATE mgw_inventory_locations SET preference=$val WHERE locationid=".$conn->QMagic($key);
            if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	}
    }

    function opUpdate() {
	global $conn, $smarty;
        $vars=array('locationid','locationtitle','description');
	// sanity checks
	if (empty($_POST["locationtitle"])) {
	    $smarty->assign("msg","Please fill in a title");
	    $smarty->display("error.tpl");
	    die;
	}
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_locations WHERE locationid != ".$conn->QMagic($_POST["locationid"]) ." AND locationtitle =".$conn->QMagic($_POST["locationtitle"]));
	if ($count > 0) {
	    $smarty->assign("msg","Title already in use");
	    $smarty->display("error.tpl");
	    die;
	}

        foreach ($vars as $var) {
            $this->set($var,$_POST["$var"]);
        }
	$this->save();
    }

    function opDelete() {
	global $conn;

	// delete the location
	$sql="DELETE FROM mgw_inventory_locations WHERE locationid=$this->locationid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function set($key,$value) {
        $this->$key=$value;
    }
}

class inv_Category {
    var $categoryid = 0;
    var $categorytitle = "";
    var $description = "";
    var $parentid = 0;
    var $displayorder = 0;
    var $categoryonly = 0;

    /*
     constructor
    */
    function inv_Category() {
        $arguments = func_get_args();
	switch(func_num_args()) {
		case 0:
			//nothing to do
			$this->categoryid=0;
			break;
		case 1:
			$this->categoryid=(int)$arguments[0];
			break;
	}
	$this->load();
    }

    function load() {
        global $conn;
        $vars=array('categorytitle','description','parentid','displayorder','categoryonly');
	$sql="SELECT * FROM mgw_inventory_category WHERE categoryid=".$this->categoryid;
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	if ($row = $res->FetchRow()) {
            foreach ($vars as $value) {
                $this->$value=$row[$value];
            }
	}
	$this->parentcatsb=inventory_make_categorysb("parentid",$this->parentid,$this->categoryid);
    }

    function save() {
        global $conn;
        $vars=array('categoryid','categorytitle','description','parentid','displayorder','categoryonly');

	// insert the info for the catgory itself
        foreach ($vars as $value) {
            $$value=$conn->QMagic($this->$value);
        }
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_category WHERE categoryid = $categoryid");
        if ($count >0) {
           $sql="UPDATE mgw_inventory_category SET categorytitle=$categorytitle,description=$description,parentid=$parentid,displayorder=$displayorder,categoryonly=$categoryonly WHERE categoryid=$categoryid";
        } else {
           $sql="INSERT INTO mgw_inventory_category (categoryid,categorytitle,description,parentid,displayorder,categoryonly)
             VALUES ($categoryid,$categorytitle,$description,$parentid,$displayorder,$categoryonly)";
        }
        if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function modify_category($mode) {
        global $smarty;
        $vars=array('categoryid','categorytitle','description','parentid','displayorder','categoryonly','parentcatsb');

	if ($mode == "newcat") {
	   $this->categoryid=mgw_genID('mgw__seq_inventory_category');
	}
        foreach ($vars as $value) {
            $smarty->assign($value,$this->$value);
        }
	$smarty->assign("mode","$mode");
	$smarty->assign("submitname","$mode");
	$smarty->assign("parentname",inventory_categorytitle($this->parentid));
	if ($mode == "newcat")
	   $smarty->assign("submitvalue",Lang::getLanguageString("new"));
	if ($mode == "editcat")
	   $smarty->assign("submitvalue",Lang::getLanguageString("edit"));
	if ($mode == "delcat")
	   $smarty->assign("submitvalue",Lang::getLanguageString("delete"));
	if ($mode == "viewcat")
	   $smarty->assign("submitvalue",Lang::getLanguageString("return"));

	if ($mode == "newcat" || $mode == "editcat") {
	    $smarty->display('inventory_admin_category_modify.tpl');
	} else {
	    $smarty->display('inventory_admin_category_view.tpl');
	}
    }

    function admin_cats() {
	global $smarty;
	$smarty->assign("categorylist",inventory_categorylist());
	$smarty->display('inventory_admin_category_list.tpl');
    }

    function admin_updatedisplayorder() {
	global $conn;
	foreach ($_POST["displayorder"] as $key => $val) {
	    $sql="UPDATE mgw_inventory_category SET displayorder=$val WHERE categoryid=".$conn->QMagic($key);
            if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	}
    }

    function opUpdate() {
	global $conn, $smarty;
        $vars=array('categoryid','categorytitle','description','parentid','categoryonly','parentid');
	// sanity checks
	if (empty($_POST["categorytitle"])) {
	    $smarty->assign("msg","Please fill in a title");
	    $smarty->display("error.tpl");
	    die;
	}
	if ($_POST["categoryid"]==$_POST["parentid"]) {
	    $smarty->assign("msg","Please choose a different parent");
	    $smarty->display("error.tpl");
	    die;
	}
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_category WHERE categoryid != ".$conn->QMagic($_POST["categoryid"]) ." AND categorytitle =".$conn->QMagic($_POST["categorytitle"]));
	if ($count > 0) {
	    $smarty->assign("msg","Title already in use");
	    $smarty->display("error.tpl");
	    die;
	}

	if (empty($_POST["categoryonly"])) {
	    $_POST["categoryonly"]=0;
	}
        foreach ($vars as $var) {
            $this->set($var,$_POST["$var"]);
        }
	$this->save();
    }

    function opDelete() {
	global $conn;

	// update all it's child categories so their parentid gets changed
	$sql="UPDATE mgw_inventory_category SET parentid=".$this->parentid." WHERE parentid=$this->categoryid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	// delete the category
	$sql="DELETE FROM mgw_inventory_category WHERE categoryid=$this->categoryid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function set($key,$value) {
        $this->$key=$value;
    }
}

class inv_Product {
    var $productid = 0;
    var $categoryid = 0;
    var $producttitle = "";
    var $categorytitle = "";
    var $disabled = "";
    var $all_columns = array();
    var $used_columns = array();
    var $obligated_columns = array();

    /*
     constructor
    */
    function inv_Product() {
        $arguments = func_get_args();
	switch(func_num_args()) {
		case 0:
			//nothing to do
			$this->productid=0;
			break;
		case 1:
			$this->productid=(int)$arguments[0];
			break;
	}
	$this->load();
    }

    function load() {
        global $conn;
        $vars=array('categoryid','producttitle','disabled');
	$sql="SELECT * FROM mgw_inventory_product WHERE productid=".$this->productid;
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	if ($row = $res->FetchRow()) {
            foreach ($vars as $value) {
                $this->$value=$row[$value];
            }
	}
	$this->categorytitle=inventory_categorytitle($this->categoryid);
	$this->all_columns();
    }

    function save(&$obligated_columns,&$prodonly_columns,&$fixed_columns,&$override_default_vals, &$override_possible_vals) {
        global $conn;
        $vars=array('productid','categoryid','producttitle','disabled');

	// insert the info for the catgory itself
        foreach ($vars as $value) {
            $$value=$conn->QMagic($this->$value);
        }
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_product WHERE productid = $productid");
        if ($count >0) {
           $sql="UPDATE mgw_inventory_product SET categoryid=$categoryid,producttitle=$producttitle,disabled=$disabled WHERE productid=$productid";
        } else {
           $sql="INSERT INTO mgw_inventory_product (productid,categoryid,producttitle,disabled)
             VALUES ($productid,$categoryid,$producttitle,$disabled)";
        }
        if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	//update the table with the used columns
	// to make it simple, first delete all column info for this category
	$sql="DELETE FROM mgw_inventory_productcols WHERE productid=$productid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	// and then reinsert it
	if (count($this->used_columns)) {
	    foreach ($this->used_columns as $key => $colid) {
		if (isset($fixed_columns[$colid])) {
		   $fixed_value="1";
		} else {
		   $fixed_value="0";
		}
		$obligated=(int)$obligated_columns[$colid];
		$prodonly=(int)$prodonly_columns[$colid];
		$possible_vals=$conn->QMagic($override_possible_vals[$colid]);
		$default_val=$conn->QMagic($override_default_vals[$colid]);
	        $sql="INSERT INTO mgw_inventory_productcols (productid, colid, fixed_value, default_val, possible_vals, obligated, prodonly)
		  VALUES ($productid,$colid,$fixed_value,$default_val,$possible_vals,$obligated,$prodonly)";
	        if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    }
	}

	// first select all itemid's for this propertyid
	$sql="SELECT itemid FROM mgw_inventory_item WHERE productid=$productid";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$used_itemids_arr=array();
	while ($row = $res->FetchRow()) {
	    $used_itemids_arr[]=$row["itemid"];
	}
	$used_itemids=implode(",",$used_itemids_arr);
	if (count($this->used_columns) && count($used_itemids_arr)) {
	    // delete the info that was entered for columns of items, when the
	    // column is no longer used
	    $used_cols=implode(",",$this->used_columns);

	    if (count($tmp_itemids)>0) {
	        $sql="DELETE FROM mgw_inventory_itemvalues WHERE itemid IN ($used_itemids) AND colid NOT IN ($used_cols)";
	        if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    }

	    // now we go into a loop for each colid, and update all items
	    // that have this colid
	    // update only if the value of the column is fixed 
	    foreach($this->used_columns as $key => $tmp_colid) {
		// product only columns are of no interest
		$prodonly=(int)$prodonly_columns[$tmp_colid];
		if ($prodonly)
			continue;
               	if (isset($fixed_columns[$tmp_colid])) {
                    $value=$conn->QMagic($override_default_vals[$tmp_colid]);
		    $sql="UPDATE mgw_inventory_itemvalues SET itemvalue=$value WHERE colid=$tmp_colid AND itemid IN ($used_itemids)";
	            if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
		}
	    }

	    // now we go into a loop for each item that could not be upgraded
	    // this means the column did not exist for this item
	    // so, we create the needed entry (with fixed or default value)
	    foreach($this->used_columns as $key => $tmp_colid) {
		$sql="SELECT itemid from mgw_inventory_itemvalues WHERE colid=$tmp_colid AND itemid IN ($used_itemids)";
		if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
		$upgraded_itemids=array();
		while ($row = $res->FetchRow()) {
		    $upgraded_itemids[]=$row["itemid"];
		}
		$not_upgraded_itemids=array_values(array_diff($used_itemids_arr,$upgraded_itemids));
	        foreach ($not_upgraded_itemids as $key => $tmp_itemid) {
		    // product only columns are of no interest
		    $prodonly=(int)$prodonly_columns[$tmp_colid];
		    if ($prodonly)
			continue;

		    // the column does not exist
		    // we insert the fixed value if defined
		    // otherwise the default value
                    if (isset($fixed_columns[$tmp_colid])) {
                        $value=$conn->QMagic($override_default_vals[$tmp_colid]);
		    } else {
		        $tmp_col=new inv_Column($tmp_colid);
                        $value=$conn->QMagic($tmp_col->default_val);
		        unset($tmp_col);
		    }
		    $sql="INSERT INTO mgw_inventory_itemvalues (itemid,colid,itemvalue) VALUES ($tmp_itemid,$tmp_colid,$value)";
	            if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
		} // END foreach ($not_upgraded_itemids
	    } // END foreach($this->used_columns
	} // END if (count($this->used_columns

    } // END function

    function modify_product($mode) {
        global $smarty, $coltypes;
        $vars=array('productid','categoryid','categorytitle','producttitle','disabled','all_columns');

	if ($mode == "newprod") {
	   $this->productid=mgw_genID('mgw__seq_inventory_product');
	}

        foreach ($vars as $value) {
            $smarty->assign($value,$this->$value);
        }

	$col_typenames=array();
	foreach ($this->all_columns as $key => $value) {
	    $coltypeid=$value["coltypeid"];
	    $col_typenames[$key]=$coltypes["$coltypeid"];
	}
	$smarty->assign("col_typenames",$col_typenames);
	$smarty->assign("categorysb",inventory_make_categorysb("categoryid",$this->categoryid));
	$smarty->assign("mode",$mode);
	$smarty->assign("submitname",$mode);
	if ($mode == "newprod")
	   $smarty->assign("submitvalue",Lang::getLanguageString("new"));
	if ($mode == "editprod")
	   $smarty->assign("submitvalue",Lang::getLanguageString("edit"));
	if ($mode == "viewprod")
	   $smarty->assign("submitvalue",Lang::getLanguageString("return"));
	if ($mode == "moveprod")
	   $smarty->assign("submitvalue",Lang::getLanguageString("move"));

	if ($mode == "newprod" || $mode == "editprod") {
	    $smarty->display('inventory_admin_product_modify.tpl');
	} else {
	    $smarty->display('inventory_admin_product_view.tpl');
	}
    }

    function admin_prods() {
	global $smarty;
	$smarty->assign("productlist",inventory_admin_productlist());
	$smarty->display('inventory_admin_product_list.tpl');
    }

    function viewcategoryproducts($categoryid) {
	global $smarty;
	$this->categoryid=$categoryid;
	$this->load();
        $smarty->assign("productlist",inventory_categoryproductlist($categoryid));
        $smarty->assign("categorytitle",$this->categorytitle);
        $smarty->display('inventory_product_list.tpl');
    }

    function viewlocationproducts($locationid) {
	global $smarty, $location;
	$smarty->assign("locationtitle",$location->locationtitle);
	$smarty->assign("locationid",$location->locationid);
        $smarty->assign("productlist",inventory_locationproductlist($locationid));
	$smarty->assign("viewperlocation","1");
        $smarty->display('inventory_product_list.tpl');
    }


    function opUpdate() {
	global $conn, $smarty;
        $vars=array('productid','categoryid','producttitle','disabled','used_columns');
	// sanity checks
	if (empty($_POST["producttitle"])) {
	    $smarty->assign("msg","Please fill in a title");
	    $smarty->display("error.tpl");
	    die;
	}
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_product WHERE productid != ".$conn->QMagic($_POST["productid"]) ." AND producttitle =".$conn->QMagic($_POST["producttitle"]));
	if ($count > 0) {
	    $smarty->assign("msg","Title already in use");
	    $smarty->display("error.tpl");
	    die;
	}

        foreach ($vars as $var) {
            $this->set($var,$_POST["$var"]);
        }
	$this->save($_POST["obligated_columns"],$_POST["prodonly_columns"],$_POST["fixed_columns"],$_POST["col"],$_POST["override_possible_vals"]);
    }

    function all_columns() {
	// here we will determine some stuff:
	// - is a column used
	// - is a column obligated (need to fill in non empty value by user)
	// - does a column have a fixed value (all items then have this value)
	// - is a column visible to the product only (items don't see this cilumn)
	global $conn;
	$this->used_columns();
	$sql="SELECT * FROM mgw_inventory_col";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row = $res->FetchRow()) {
	    if (isset($this->used_columns[$row["colid"]])) {
		$row["used"]=1;
		$row["obligated"]=$this->used_columns[$row["colid"]]["obligated"];
		$row["fixed_value"]=$this->used_columns[$row["colid"]]["fixed_value"];
		$row["prodonly"]=$this->used_columns[$row["colid"]]["prodonly"];
		if (!empty($this->used_columns[$row["colid"]]["default_val"])) {
		   $row["default_val"]=$this->used_columns[$row["colid"]]["default_val"];
		}
		if (!empty($this->used_columns[$row["colid"]]["possible_vals"])) {
		   $row["override_possible_vals"]=$this->used_columns[$row["colid"]]["possible_vals"];
		}
	    } else {
		$row["used"]=0;
		$row["obligated"]=0;
		$row["fixed_value"]="";
		$row["prodonly"]=0;
	    }
	    // when editing a product, small_input=1 to get more fields on 1 screen
	    $small_input=1;
	    $row["render_default_val"]=inventory_render_column_input_field($row,"",$row["default_val"],$small_input);
	    $this->all_columns[]=$row;
	}
    }

    function used_columns() {
	global $conn;
	$sql="SELECT * FROM mgw_inventory_productcols WHERE productid=$this->productid";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row = $res->FetchRow()) {
	    #$this->used_columns[$row["colid"]]=1;
	    $this->obligated_columns[$row["colid"]]=$row["obligated"];
	    $this->used_columns[$row["colid"]]=$row;
	}
    }

    function set($key,$value) {
        $this->$key=$value;
    }
}

class inv_Column {
    var $colid=0;
    var $coltitle="";
    var $displayorder=0;
    var $default_val="";
    var $possible_vals="";
    var $coltypeid="";
    var $coltypename="";
    var $coltypesize=0;
    
    /*
     constructor
    */
    function inv_Column() {
        $arguments = func_get_args();
        switch(func_num_args()) {
                case 0:
                        //nothing to do
                        $this->colid=0;
                        break;
                case 1:
                        $this->colid=(int)$arguments[0];
                        break;
        }
        $this->load();
    }

    function admin_cols() {
	global $smarty;
	$smarty->assign("collist",inventory_collist());
	$smarty->display('inventory_admin_column_list.tpl');
    }

    function load() {
        global $conn, $coltypes;
        $vars=array('colid','coltitle','displayorder','default_val','possible_vals','coltypeid','coltypesize');
        $sql="SELECT * FROM mgw_inventory_col WHERE colid=$this->colid";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        if ($row = $res->FetchRow()) {
            foreach ($vars as $value) {
                $this->$value=$row[$value];
            }
        } 
        $this->coltypename=$coltypes[$this->coltypeid];
    }

    function modify_column($mode) {
        global $smarty;
        $vars=array('colid','coltitle','default_val','possible_vals','coltypeid','coltypesize','coltypename');

        foreach ($vars as $value) {
            $smarty->assign($value,$this->$value);
        }
	$smarty->assign("all_coltypessb",inventory_all_coltypes($this->coltypeid));
	$smarty->assign("mode","$mode");
	$smarty->assign("submitname","$mode");
	if ($mode == "newcol")
	   $smarty->assign("submitvalue",Lang::getLanguageString("new"));
	if ($mode == "editcol")
	   $smarty->assign("submitvalue",Lang::getLanguageString("edit"));
	if ($mode == "delcol")
	   $smarty->assign("submitvalue",Lang::getLanguageString("delete"));
	if ($mode == "viewcol")
	   $smarty->assign("submitvalue",Lang::getLanguageString("return"));

	if ($mode == "newcol" || $mode == "editcol") {
	    $smarty->display('inventory_admin_column_modify.tpl');
	} else {
	    $smarty->display('inventory_admin_column_view.tpl');
	}
    }

    function opUpdate() {
	global $conn;
        $vars=array('colid','coltitle','default_val','possible_vals','coltypeid','coltypesize');
        foreach ($vars as $value) {
            $$value=$conn->QMagic($_POST["$value"]);
        }

	/// some sanity checks
	if (empty($_POST["coltitle"])) {
	    $smarty->assign("msg","Please fill in a title");
	    $smarty->display("error.tpl");
	    die;
	}
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_col WHERE colid != $colid AND coltitle=$coltitle");
	if ($count > 0) {
	    $smarty->assign("msg","Title already in use");
	    $smarty->display("error.tpl");
	    die;
	}

	// Now insert into the DB
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_col WHERE colid = $colid");
	if ($count > 0) {
	    $sql="UPDATE mgw_inventory_col SET coltitle=$coltitle,default_val=$default_val,possible_vals=$possible_vals,coltypeid=$coltypeid,coltypesize=$coltypesize WHERE colid=$colid";
	} else {
	    $sql="INSERT INTO mgw_inventory_col (coltitle,default_val,possible_vals,coltypeid,coltypesize) VALUES ($coltitle,$default_val,$possible_vals,$coltypeid,$coltypesize)";
	}
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function opDelete() {
	global $conn;
	// delete the column itself
	$sql="DELETE FROM mgw_inventory_col WHERE colid=$this->colid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	// delete category definition of this column
	$sql="DELETE FROM mgw_inventory_productcols WHERE colid=$this->colid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	// delete all item values for this column
	$sql="DELETE FROM mgw_inventory_itemvalues WHERE colid=$this->colid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function admin_updatedisplayorder() {
	global $conn;
	foreach ($_POST["displayorder"] as $key => $val) {
	    $sql="UPDATE mgw_inventory_col SET displayorder=$val WHERE colid=".$conn->QMagic($key);
            if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	}
    }
}

class inv_Item {
    var $columns=array();
    var $columnvalues=array();
    var $itemid=0;
    var $product;
    var $locationid=0;
    var $locationtitle="";

    function inv_Item ($itemid,$productid=0,$locationid=0,$default_values=0,$fixed_values=0) {
	// you give as possible extra options:
	// - the productid (which defines the columns used ans such
	// - the locationid
	// - default values (array with index the columnid)
	// - extra fixed_values (an array, index is the columnid. If filled in
	//    the value will be used as fixed value for that columnid.
	//    This overrides possible fixed values defined for the product)
        $this->itemid=(int)$itemid;
        $this->load((int)$productid,(int)$locationid,$default_values,$fixed_values);
    }

    function modify($mode) {
	global $smarty;
	if ($mode == "newitem" && $this->product->disabled==1) {
	    $smarty->assign("msg","Product disabled, no new items possible");
	    $smarty->display("error.tpl");
	    die;
	}
	if ($mode == "newitem") {
	   $this->itemid=mgw_genID('mgw__seq_inventory_item');
	}
	$smarty->assign("itemid", $this->itemid);
	$smarty->assign("productid", $this->product->productid);
	$smarty->assign("producttitle",$this->product->producttitle);
	$smarty->assign("categorytitle",$this->product->categorytitle);
	$smarty->assign("sorted_columns", $this->sorted_columns());
	$smarty->assign("obligated_columns", $this->product->obligated_columns);
	$smarty->assign("columns", $this->columns);
	$smarty->assign("columnvalues", $this->columnvalues);
	$smarty->assign("locationsb",inventory_make_locationsb());
	$smarty->assign("locationtitle",$this->locationtitle);

	$smarty->assign("mode","$mode");
	$smarty->assign("submitname","$mode");
	if ($mode == "newitem")
	   $smarty->assign("submitvalue",Lang::getLanguageString("new"));
	if ($mode == "edititem") {
	   $smarty->assign("submitvalue",Lang::getLanguageString("edit"));
	}
	if ($mode == "delitem")
	   $smarty->assign("submitvalue",Lang::getLanguageString("delete"));
	if ($mode == "viewitem")
	   $smarty->assign("submitvalue",Lang::getLanguageString("return"));

	$smarty->display('inventory_item.tpl');
    }

    function opUpdate() {
	global $conn, $smarty;

	// first check that all obligated columns are filled in
	foreach ($_POST["col"] as $key => $value) {
	    if (empty($value) && $this->product->obligated_columns[$key]==1) {
	        $smarty->assign("msg","Please fill in a value for '".$this->columns[$key]["coltitle"]."'");
	        $smarty->display("error.tpl");
	        die;
	    }
	}

	// if it is a new item, the link between itemid, productid and
	// locationid has to be made
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_item WHERE itemid = $this->itemid");
	$productid=$this->product->productid;
	if ($count == 0) {
	    if ($this->product->disabled==1) {
	        $smarty->assign("msg","Product disabled, no new items possible");
	        $smarty->display("error.tpl");
	        die;
	    }
	    $sql="INSERT INTO mgw_inventory_item (itemid, productid, locationid) VALUES ($this->itemid, $productid, $this->locationid)";
	    if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    inventory_AddHistory($this->itemid,"added to the inventory");
	}

	// now update all the itemvalues
	$sql="DELETE FROM mgw_inventory_itemvalues WHERE itemid=$this->itemid";
	if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	foreach ($_POST["col"] as $key => $value) {
	    $sql="INSERT INTO mgw_inventory_itemvalues (itemid,colid,itemvalue) VALUES ($this->itemid, $key, ".$conn->QMagic($value).")";
	    if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    inventory_AddHistory($this->itemid,"value for '".$this->columns[$key][coltitle]."' changed to '$value'");
	}

	// we return the itemid here, so that, for newly created items
	// we know it's id. Is sefull if you create an item from within
	// another application and want to do something with it afterwards
	return ($this->itemid);
    }

    function opDelete() {
	global $conn;
	// delete the category
	$sql="DELETE FROM mgw_inventory_item WHERE itemid=$this->itemid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$sql="DELETE FROM mgw_inventory_itemvalues WHERE itemid=$this->itemid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function opMove($locationid) {
	global $conn;
	$sql="UPDATE mgw_inventory_item SET locationid=$locationid WHERE itemid=$this->itemid";
	if (!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $locationtitle=$conn->GetOne("SELECT locationtitle FROM mgw_inventory_locations WHERE locationid = $locationid");
	inventory_AddHistory($this->itemid,"moved to location '$locationtitle'");
    }

    function changeonevalue($colid,$newvalue) {
    // Changes the value of $colid of the this item instance to a new value
    // checks if the value is not already the new value or if it hasn't been
    // changed before the LOCK was obtained
    // returns 0 upon failure, 1 upon success
    // THIS FUNCTION IS CALLED FROM AN ITEM INSTANCE, NOT FROM THE MAIN
    // index.php OF THE INVENTORY MODULE. THIS IS IN FACT AN API FOR OTHER
    // PROGRAMS TO SAFELY CHANGE SOMETHING OF AN ITEM
	global $conn, $smarty;
	// LOCK the needed table itemvalues
 	// (when using LOCK, you need to lock *all* tables used in queries during the lock)
	$sql="LOCK TABLES mgw_inventory_item WRITE, mgw_inventory_itemvalues WRITE";
	if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	// if the colid doesn't exist for the requested itemid, we don't proceed
	$test=$conn->GetOne("SELECT itemid FROM mgw_inventory_itemvalues WHERE itemid=$this->itemid AND colid=$colid");
	if ($test == "") {
	    $smarty->assign("msg","Column does not exist for this item");
	    $smarty->display("error.tpl");
	    $sql="UNLOCK TABLES";
	    if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    exit;
	}

	$tmp_value=$conn->GetOne("SELECT itemvalue FROM mgw_inventory_itemvalues WHERE itemid=$this->itemid AND colid=$colid");
	// now first check if, just before the lock somebody else
	// already changed this itemvalue
	// or the value is already that what you want
	if (($tmp_value != $this->columnvalues[$colid]["itemvalue"]) ||
	    ($tmp_value == $newvalue)) {
	    $sql="UNLOCK TABLES";
	    if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    return 0;
	} else { 
	    $sql="UPDATE mgw_inventory_itemvalues set itemvalue=".$conn->QMagic($newvalue)." WHERE itemid=$this->itemid AND colid=$colid";
	    // this sql may not exit upon failure, otherwise the LOCK stays
	    if (!$res=$conn->Execute($sql)) { 
		$smarty->assign("msg","Failure executing $sql");
	        $smarty->display("error.tpl");
	    }
	    $sql="UNLOCK TABLES";
	    if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    inventory_AddHistory($this->itemid,"Changed value of ".$this->columns[$colid]["coltitle"]." from $tmp_value to $newvalue");
	    return 1;
	}
    }

    function load($productid,$locationid,$default_values,$fixed_values) {
	global $conn, $coltypes, $smarty;

	// if it is a new item, productid and locationid are the ones
	// given as argument, else it's the one found in the db
        $count=$conn->GetOne("SELECT count(*) AS count FROM mgw_inventory_item WHERE itemid = $this->itemid");
	if ($count == 0) {
	    $this->locationid=$locationid;
	} else {
            $productid=$conn->GetOne("SELECT productid FROM mgw_inventory_item WHERE itemid = $this->itemid");
            $this->locationid=$conn->GetOne("SELECT locationid FROM mgw_inventory_item WHERE itemid = $this->itemid");
	}
	$this->product=new inv_Product($productid);
        $this->locationtitle=$conn->GetOne("SELECT locationtitle FROM mgw_inventory_locations WHERE locationid = $this->locationid");

	
	// select all the filled in itemvalues for this item
	$sql="SELECT * FROM mgw_inventory_itemvalues WHERE itemid=$this->itemid";
	if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row=$res->FetchRow()) {
	   $this->columnvalues[$row["colid"]]=$row;
	}

	// get a list of all columns for the product of this item
	$productid=$this->product->productid;
	$sql="SELECT col.* from mgw_inventory_col col, mgw_inventory_productcols prod WHERE prod.prodonly=0 AND col.colid=prod.colid AND prod.productid=".$productid;
	if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row=$res->FetchRow()) {
	   $this->columns[$row["colid"]]=$row;
	}

	// if own default values were given as parameter, use these
	if (is_array($default_values)) {
	   foreach ($default_values as $key=>$val) {
	      if (isset($this->columns[$key])) {
	         $this->columns[$key]["default_val"]=$val;
	      }
	   }
	}

	$sql="SELECT colid, default_val, possible_vals from mgw_inventory_productcols prod WHERE prod.prodonly=0 AND prod.productid=".$productid;
	if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	while ($row=$res->FetchRow()) {
	   if (!empty($row["possible_vals"])) {
	      $this->columns[$row["colid"]]["possible_vals"]=$row["possible_vals"];
	   }
	   if (!empty($row["default_val"])) {
	      $this->columns[$row["colid"]]["default_val"]=$row["default_val"];
	   }
	}

	foreach ($this->columns as $key=>$col) {
	    if (is_array($fixed_values) && isset($fixed_values[$key])) {
		$fixedvalue=$fixed_values[$key];
	    } else {
	       // select the (possible empty) fixed value of the product
	       // for this column
               $fixedvalue=$conn->GetOne("SELECT default_val FROM mgw_inventory_productcols WHERE productid =".$productid." AND colid=$key AND fixed_value=1");
	    }
	    // when editing a product, small_input=1 to get more fields on 1 screen
	    $small_input=0;
	    $this->columns[$key]["input"]=inventory_render_column_input_field($col,$fixedvalue,$this->columnvalues[$key]["itemvalue"],$small_input);
	}
    }

    function sorted_columns() {
	// smarty template will use this array for looping through the
	// columns in the defined displayorder
	// we leave out the columns that are reserved for the product only
	global $conn;
	$productid=$this->product->productid;
	$sql="SELECT col.colid, col.displayorder FROM mgw_inventory_col col, mgw_inventory_productcols b WHERE b.prodonly=0 AND b.productid=".$productid." AND col.colid=b.colid ORDER BY col.displayorder ASC";
        if (!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$result=array();
	while ($row = $res->FetchRow()) {
	    $result[]=$row["colid"];
	}
	return $result;
    }

    function viewitems() {
	global $conn, $smarty, $appconf, $location;
	$result=array();

        // Paging Part
        // if user wants icons, assign icons if not -> not
        if ($_SESSION["MGW"]->settings["iconmode"]==1) {
            $prevsym = "<img src=\"". $appconf["imgpathgeneral"]. "/left_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\">";
            $nextsym = "<img src=\"". $appconf["imgpathgeneral"]. "/right_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\">";
            $smarty->assign("iconid", $_SESSION["MGW"]->settings["iconid"]);
            $smarty->assign("iconmode", true);
        } else {
            $prevsym = "&lt;&lt;--|";
            $nextsym = "|--&gt;&gt;";
            $smarty->assign("iconmode", false);
        }
        $prevlink="?action=viewitems&productid=".$this->product->productid."&amp;ppage=1";
        $nextlink="?action=viewitems&productid=".$this->product->productid."&amp;npage=1";
        // set the page number
        // defaults to 0
        if (isset($_REQUEST["page"])) {
                $page = (int)$_REQUEST["page"];
        } else {
                $page = 1;
        }
        $prevpage=$page-1;
        $nextpage=$page+1;
        $prevlink .= "&amp;page=$prevpage";
        $nextlink .= "&amp;page=$nextpage";

        if (isset($_REQUEST["search"])) {
	    if (get_magic_quotes_gpc()) {
	        $tmp_value=urlencode(stripslashes($_REQUEST["itemvalue"]));
	    } else {
	        $tmp_value=urlencode($_REQUEST["itemvalue"]);
	    }
	
	    $prevlink .= "&amp;search=1&amp;colid=".$_REQUEST["colid"]."&amp;itemvalue=$tmp_value";
	    $nextlink .= "&amp;search=1&amp;colid=".$_REQUEST["colid"]."&amp;itemvalue=$tmp_value";
	}

	$sql_location="";
        if (isset($_REQUEST["locationid"])) {
	    $prevlink .= "&amp;locationid=".$_REQUEST["locationid"];
	    $nextlink .= "&amp;locationid=".$_REQUEST["locationid"];
	    $sql_location=" AND locationid=".$_REQUEST["locationid"];
	}

        $prevlink="<A HREF=\"$prevlink\">$prevsym</A>";
        $nextlink="<A HREF=\"$nextlink\">$nextsym</A>";
        // End Paging Part

	$productid=$this->product->productid;
	// get a list of all (searched) items in this category
        if (isset($_REQUEST["search"])) {
	    $colid=(int)$_REQUEST["colid"];
	    $itemvalue=$conn->QMagic($_REQUEST["itemvalue"]);
	    $sql="SELECT itemvalues.itemid FROM mgw_inventory_itemvalues itemvalues, mgw_inventory_item item WHERE itemvalues.colid=$colid and itemvalues.itemvalue=$itemvalue AND item.itemid=itemvalues.itemid AND item.productid=".$productid.$sql_location;
        } else {
	    $sql="SELECT itemid FROM mgw_inventory_item WHERE productid=".$productid.$sql_location;
	}
        if (!$res = $conn->PageExecute($sql, $_SESSION["MGW"]->settings["list_items_number"], $page))
	    exit(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
	$all_itemids=array();
	while ($row=$res->FetchRow()) {
	    $all_itemids[]=$row["itemid"];
	}
        if (!$res->AtFirstPage()) {
            $smarty->assign("prevlink", $prevlink);
        }
        // if NOT on last page
        if (!$res->AtLastPage()) {
            $smarty->assign("nextlink", $nextlink);
        }

	// for each item, get the value of it's columns
	$result=array();
	$i=0;
	foreach ($all_itemids as $key => $tmp_itemid) {
	    $sql="SELECT * FROM mgw_inventory_itemvalues WHERE itemid=$tmp_itemid";
	    if (!$res=$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    while ($row=$res->FetchRow()) {
		$result[$i][$row["colid"]]=$row;
	    }
	    $tmp_locationtitle=$conn->GetOne("SELECT loc.locationtitle FROM mgw_inventory_item item, mgw_inventory_locations loc WHERE item.itemid=$tmp_itemid and loc.locationid=item.locationid");
	    $result[$i]["itemid"]=$tmp_itemid;
	    $result[$i]["locationtitle"]=$tmp_locationtitle;
	    $i++;
	}

	// sorted_columns will be used by the template
	// to display column headers and all_items in the right order
	$smarty->assign("sorted_columns", $this->sorted_columns());
	$smarty->assign("column_headers", $this->columns);
	$smarty->assign("productid", $this->product->productid);
	$smarty->assign("producttitle",$this->product->producttitle);
	$smarty->assign("categorytitle",$this->product->categorytitle);
	$smarty->assign("locationid",$this->locationid);
	$smarty->assign("locationtitle",$this->locationtitle);
	$smarty->assign("productdisabled",$this->product->disabled);
	$smarty->assign("all_items", $result);
        if (isset($_REQUEST["locationid"])) {
	    $smarty->assign('viewperlocation',"1");
	}
	$smarty->display('inventory_item_list.tpl');
    }

}
?>
