<?php

  /*
   This file is part of MoreGroupWare's webmail2 module
   Copyright 2004-2005 Franky Van Liedekerke
   This module is released under the GPL (as stated below).

   Originally written by Thomas Bley (info@simple-groupware.de),
   now adapted and maintained by Franky Van Liedekerke.

   You should have received a copy of the GNU General Public License
   along with mgw; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

$myEnv["module"] = "webmail2";
$myEnv["stdsmenu"] = false;
$myEnv["output"] = "html";

include("../../config.inc.php");
include(INCLUDEPATH . "container.inc.php");
include(WM2_INC_DIR."imap/date.php");
include(WM2_INC_DIR.'readmessage_inc.php');

// always clear the attachment dir for this session
// fix for bugID 940030
// Added by Franky
include(WM2_INC_DIR.'sendmail_post_inc.php');
delete_open_attachments(CACHE_FOLDER."$username/sendmail/");

error_reporting  (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

$myvars = array("msg_no","print","inline","print2","account","mbox_id","word_export","show_headers");
foreach ($myvars as $thevar) {
  ${$thevar} = (isset($_GET[$thevar])) ? $_GET[$thevar] : (isset($_POST[$thevar]) ? $_POST[$thevar] : "");
}

if ($print=="true") { $print2="onload=\"print();\""; }

$message_id = "";
$this_recache = false;

// mark message as read
store_webmail_readmessage($msg_no);

if ($account!=0 and $mbox_id != "" and is_numeric($mbox_id)) {

  if ($email = connect_my_imap($account,$mbox_id,true)) {

    $header = my_imap_header($email,$email,"int",$msg_no);
    if (isset($header->Size)) {$size = $header->Size;} else {$size = "0";}

    $oversize = false;
    if (isset($MGW->settings["wm2_fetch_limit"]) and $MGW->settings["wm2_fetch_limit"] != "" and is_numeric($MGW->settings["wm2_fetch_limit"]) and $MGW->settings["wm2_fetch_limit"]!=0 and ($MGW->settings["wm2_fetch_limit"]*1024) < $header->Size) {
      show_webmail_error("mail is too big.");
    }
    $message_id = str_replace(array(".","<",">","/"),"",$header->message_id);
        
    $act_name = CACHE_FOLDER."$username/imap/eml/".$message_id.".eml";
    $emailsource = $act_name;
    $emailsource_mini = CACHE_FOLDER."$username/imap/readmessage/".$message_id.".php";
        
    if (!file_exists($act_name)) {
      $actname_temp = CACHE_FOLDER ."$username/imap/eml/temp-".$user_id.$username.".eml";

      @set_time_limit(0);

      my_imap_get_message($email,$email,"ing",$msg_no,$actname_temp);
      if (!file_exists($actname_temp)) {
         show_webmail_error(Lang::getLanguageString("fetchmail_error"),'');
      }

      if (file_exists($act_name)) {unlink($act_name);}
      rename($actname_temp,$act_name);
    }
    sqimap_messages_add_flag ($email, $msg_no, $msg_no, "\\Seen");
    sqimap_logout($email);

    $row2 = array();
    $row2["header_bcc"] = "";
    $row2["attachbit"] = "";
    $row2["notified"] = "";
    $row2["header_from"] = decode_mime_string(trim(isset($header->fromaddress)?$header->fromaddress:""));
    $row2["header_to"] = decode_mime_string(trim(isset($header->toaddress)?$header->toaddress:""));
    $row2["header_cc"] = decode_mime_string(trim(isset($header->ccaddress)?$header->ccaddress:""));
    $row2["header_replyto"] = decode_mime_string(isset($header->reply_toaddress)?$header->reply_toaddress:"");
    $row2["header_subject"] = decode_mime_string(isset($header->subject)?$header->subject:"");
    $row2["header_date"] = (isset($header->date)?$header->date:"");
    $row2["uid"] = (isset($header->message_id)?$header->message_id:"");
    $row2["flaggedbit"] = (isset($header->priority)?$header->priority:"");
        
  } else {
    $msg_no="";
  }
}    

if ($msg_no!="" and ($account!=0 or has_write_rights_mail($msg_no,$user_id))) {
  $settings_replyto = array();
  $settings_fullname = array();
  $sql = "select replyto, fullname from mgw_webmail2_accounts where user_id=".(int)$user_id;
  if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  while($row = $res->FetchRow()) {
    $settings_replyto[] = strtolower($row["replyto"]);
    $settings_fullname[] = $row["fullname"];
  }

  $replied = array();
  $forwarded = array();
  $replier2 = "";
  
  if ($account == 0) {
    $sql = "select * from mgw_webmail2_messages where message_id=".(int)$msg_no;
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    $row = $res->FetchRow();
  
    if ($row["header_size"]!=0) {$mysize=format_filesize($row["header_size"]);} else {$mysize="";}
  
    $msg_cache = $row["msg_cache"];

    if ($msg_cache=="") {
      $msg_cache = ereg_replace("/","X",md5(mt_rand(1,6000)));
      $sql = "update mgw_webmail2_messages set msg_cache='".$msg_cache."' where message_id=".(int)$msg_no;
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    }

    if ($row["replybit"]==1 and $row["replied"]!="") {
      $repliers = explode(";@;",$row["replied"]);
      foreach ($repliers as $replier) {
        if ($replier !="") {
    	  $replied[] = explode(";#;",$replier);
	}
      }
    }
  
    if ($row["replied2"]!="") {
      $replier2 = $row["replied2"];
    }
  
    if ($row["forwardbit"]==1 and $row["forwarded"]!="") {
      $forwarders = explode(";@;",$row["forwarded"]);
      foreach ($forwarders as $forwarder) {
        if ($forwarder !="") {
	  $forwarded[] = explode(";#;",$forwarder);
        }
      }
    }
  
    // readbit=1 means unread, 0 means read
    // this should change ...
    if ($row["readbit"]==1) {
      $this_recache = true;
      $sql = "update mgw_webmail2_messages set readbit=0 where message_id=".(int)$msg_no;
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    }
  
    $emailsource = $row["msg_body"];
    $emailsource_mini = CACHE_FOLDER."$username/readmessage/".basename($row["msg_body"]).".php";

  } else {
    if ($size!=0) {$mysize=format_filesize($size);} else {$mysize="";}
  
    $row = $row2;
  
  }
  $global_row = $row;

  $emailsourcelink = '<a target="_blank" href="'.$emailsource.'" onclick="return confirm(\''.Lang::getLanguageString("readmessage_email_source_warning").'\');">';

  require_once(WM2_INC_DIR."pear/Mail/mimedecode.php");
  require_once(WM2_INC_DIR."pear/Mail/RFC822.php");
  
  $attachments2 = array();
  $boundarys = array();
  $content_types = array();
  
  $content_type = ""; $content_transfer_encoding = ""; $content_disposition = "";
  $filename = "";	$filename2 = "";
  $cont2 = ""; $input = "";
  $inline2 = "";
	
  $rfc = false;
    
  $record = false; $write_attach = false;
  $firsttime = true;
  $block_filename = false;	
    
  $partno = 0;
  $realattachments = 0;
		
  $cache_version_now = "2.6";
  $cache_version_now2 = "2.7";
	
  $recache = true;

  @set_time_limit(0);

  if ($MGW->settings["wm2_always_recache"] or $this_recache) {
    $recache = true;
  }
	
  if (file_exists($emailsource_mini)) {
    include $emailsource_mini;
    
    if ($MGW->settings["wm2_enableinline"]) { $wm2_enableinline = "checked"; } else { $wm2_enableinline = ""; }
    if ($MGW->settings["wm2_securehtmlmails"]) { $wm2_securehtmlmails = "checked"; } else { $wm2_securehtmlmails = ""; }
    if (!isset($cache_version)) {$cache_version = "0";}
    if ($cache_version2 == $cache_version_now2
	and $inline2 == $wm2_enableinline
	and $secure2 == $wm2_securehtmlmails
	) { $recache = false; }
  }
  
  if ($MGW->settings["wm2_always_recache"]) {
    $recache = true;
  }
  if ($recache) {
    $emailbox = array();
    $msg_id = $msg_no;  
    $params = array(
		    'crlf'           => "\r\n",
		    'include_bodies' => TRUE,
		    'decode_headers' => TRUE,
		    'decode_bodies'  => TRUE
		    );

    $webmails = "";
    $body_plain = "";
    $body_show = "";
    $notify = false;

    if (!file_exists($emailsource) or !$fp=@fopen($emailsource,"rb")) {
      show_webmail_error("<br>".Lang::getLanguageString("readmessage_email_not_found")."<br>".Lang::getLanguageString("readmessage_number_in_db").$msg_no."<br>".Lang::getLanguageString("readmessage_filename_disabled"),'');
    }

    // the Pear::Mail_mimedecode needs at least twice the amount
    // of memory as the size of the email, so:
    // memory usage until here=3,6MB
    // memory usage after decoding a 3MB mail (with 2 images as content)=9,6MB
    // and then the structure variable needs another 3MB (a bit less), so:
    // totally 12,6 MB is needed temporary
    // the memory is released directly after, but you might bump into this 
    // limit in php.ini
    $decoder = new Mail_mimeDecode(implode('',file($emailsource)));
    unset($structure);
    $structure = $decoder->decode($params);
    unset($decoder);
    if (PEAR::isError($structure)) {
       show_webmail_error(Lang::getLanguageString("readmessage_error_decode"),$structure->message);
    }

    // if no parts, we add one because we only loop through the parts
//    if (!isset($structure->parts)) {
//      $structure->parts[0]->headers=$structure->headers;
//      if (isset($structure->ctype_primary)) {
//         $structure->parts[0]->ctype_primary=$structure->ctype_primary;
//      }
//      if (isset($structure->ctype_secondary)) {
//         $structure->parts[0]->ctype_secondary=$structure->ctype_secondary;
//      }
//      if (isset($structure->ctype_parameters)) {
//         $structure->parts[0]->ctype_parameters=$structure->ctype_parameters;
//      }
//      if (isset($structure->body)) {
//         $structure->parts[0]->body=$structure->body;
//      }
//      $structure->parts[0]->parts=array();
//    }

    list($body_plain,$body_show,$emailbox) = make_emailbox_array($structure);
    unset($structure);

    $fp = fopen($emailsource_mini, "w");

    fwrite($fp,"<?php\n");
    
    fwrite($fp,"\$cache_version2=\"".$cache_version_now2."\";\n");

    if ($MGW->settings["wm2_enableinline"]) { $wm2_enableinline = "checked"; } else { $wm2_enableinline = ""; }
    if ($MGW->settings["wm2_securehtmlmails"]) { $wm2_securehtmlmails = "checked"; } else { $wm2_securehtmlmails = ""; }

    $from2 = shorten2($row["header_from"]);
    fwrite($fp,"\n\$cache_from=\"".addcslashes((user_exists($from2)?$from2:$row["header_from"]),"\$\\\"")."\";\n");
    fwrite($fp,"\$cache_to=\"".addcslashes($row["header_to"],"\$\\\"")."\";\n");
    fwrite($fp,"\$cache_cc=\"".addcslashes($row["header_cc"],"\$\\\"")."\";\n");
    fwrite($fp,"\$cache_bcc=\"".addcslashes($row["header_bcc"],"\$\\\"")."\";\n");
    fwrite($fp,"\$cache_replyto=\"".addcslashes($row["header_replyto"],"\$\\\"")."\";\n");
    fwrite($fp,"\$cache_uid=\"".addcslashes($row["uid"],"\$\\\"")."\";\n");
    fwrite($fp,"\$cache_date=\"".$row["header_date"]."\";\n");
    fwrite($fp,"\$cache_flaggedbit=\"".$row["flaggedbit"]."\";\n");
    fwrite($fp,"\$cache_subject=\"".addcslashes(htmlnonspecialchars($row["header_subject"]),"\$\\\"")."\";\n\n");

    fwrite($fp,"\$inline2=\"".$wm2_enableinline."\";\n");
    fwrite($fp,"\$secure2=\"".$wm2_securehtmlmails."\";\n");

    $body_plain = str_replace("&quot;","\"",$body_plain);
    
    fwrite($fp,"\$body_plain=\"");
    fwrite($fp,addcslashes($body_plain,"\$\\\""));
    fwrite($fp,"\";\n");
	
    if (count($emailbox)!=0) {
      fwrite($fp,"\$emailbox=");
      fwrite($fp, draw_array($emailbox,true));
    } else {
      fwrite($fp,"\$emailbox=array();\n");
    }
  
    fwrite($fp,"\$body_show=\"");
    fwrite($fp,addcslashes($body_show,"\$\\\""));
    fwrite($fp,"\";\n");

    fwrite($fp,"?>\n");
    fclose($fp);
  }

  if ($show_headers=="true") {
	$input=implode('',file($emailsource));
	$body_show=nl2br(htmlspecialchars($input))."<br><br>";
	unset($input);
  }

  $smarty->assign("emailbox", make_emailbox_html($emailbox));
  
  $smarty->assign("msg_no", $msg_no);
  $smarty->assign("account", $account);
  $smarty->assign("mbox_id", $mbox_id);
  $smarty->assign("webmails", $body_show);

  $realattachments=count($emailbox[11]);
  if ($realattachments != 0 and $account==0 and $row["readbit"]==0) {
    $sql = "update mgw_webmail2_messages set attachbit=1 where message_id=".(int)$msg_no;
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  } else if ($realattachments == 0 and $row["attachbit"]==1) {
    $sql = "update mgw_webmail2_messages set attachbit=0 where message_id=".(int)$msg_no;
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  }

} // msgno!=""

if ($print == "true" and $word_export == "true") {
  header("Content-type: application/msword"); // application/vnd.ms-powerpoint
  header("Content-Disposition: attachment; filename=".$row["message_id"].".doc");

  $smarty->register_outputfilter("smarty_remove_all_links");
  $print2 = "";
}

$smarty->assign("print", $print);
$smarty->assign("print2", $print2);

if ($notify and !$row["notified"] and $row["readbit"]==1 and isset($MGW->settings["wm2_accept_receipt"]) and $MGW->settings["wm2_accept_receipt"]!="") {
  $smarty->assign("notify", $notify);
  $temp = shorten2($row["header_from"]);
  $reply_account_id=$conn->GetOne("select account_id from mgw_webmail2_messages where message_id=".(int)$msg_no);
  if (!user_exists($temp)) $temp = get_all_email_addresses($row["header_from"]);
  $smarty->assign("notify_url", "sendmail_notify.php?&to=".strtolower($temp)."&subject=".urlencode($row["header_subject"])."&inreplyto=".htmlspecialchars($row["uid"])."&date=".$row["header_date"]."&msg_no=".$msg_no."&reply_account_id=".$reply_account_id."&".SID);
 }

 $smarty->display("readmessage.tpl");
?>
