<?php

// $Header: /cvsroot/moregroupware/mgw/modules/workflow/tiki-g-run_activity.php,v 1.5 2004/04/29 14:49:29 liedekef Exp $

// Copyright (c) 2002-2003, Luis Argerich, Garland Foster, Eduardo Polidor, et. al.
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.
//include ('tiki-setup.php');

// run without authentication when auto is set
// FIXME: and only when this is done from localhost!!!
if (isset($_REQUEST['auto']) && $_SERVER["REMOTE_ADDR"]=="127.0.0.1") {
     $myEnv["auth"]=false;
}

require_once ('setup-base.php');
include (GALAXIA_LIBRARY.'/API.php');
include_once ("inc/webmail/htmlMimeMail.php");

$__activity_completed = false;

if ($feature_workflow != 'y') {
	$smarty->assign('msg', tra("This feature is disabled").": feature_workflow");
	$smarty->display("workflow_error.tpl");
	die;
}

if (!isset($_REQUEST['auto'])) {
	if ($tiki_p_use_workflow != 'y') {
		$smarty->assign('msg', tra("Permission denied"));
		$smarty->display("workflow_error.tpl");
		die;
	}
} else {
        // autorun activities always need an instance id
	if (!isset($_REQUEST['iid'])) {
		$smarty->assign('msg', tra("No instance indicated"));
		$smarty->display("workflow_error.tpl");
		die;
	}
}

// Determine the activity using the activityId request
// parameter and get the activity information
// load then the compiled version of the activity
if (!isset($_REQUEST['activityId'])) {
	$smarty->assign('msg', tra("No activity indicated"));
	$smarty->display("workflow_error.tpl");
	die;
}

$activity = $baseActivity->getActivity((int)$_REQUEST['activityId']);
$process->getProcess($activity->getProcessId());

if (isset($_REQUEST['iid']) && (empty($instance->instanceId) || $instance->instanceId==0)) {
    $instance->getInstance((int)$_REQUEST['iid']);
}

// Get user roles

// Get activity roles
$act_roles = $activity->getRoles();
$user_roles = $activity->getUserRoles($username);

// Only check roles if this is an interactive
// activity
if ($activity->isInteractive() == 'y') {
	if (!count(array_intersect($act_roles, $user_roles))) {
		$smarty->assign('msg', tra("You cant execute this activity"));
		$smarty->display("workflow_error.tpl");
		die;
	}
}

$source = GALAXIA_PROCESSES. $process->getNormalizedName(). '/compiled/' . $activity->getNormalizedName(). '.php';
$shared = GALAXIA_PROCESSES. $process->getNormalizedName(). '/code/shared.php';

// Existing variables here:
// $process, $activity, $instance (if not standalone)

// Include the shared code
include_once ($shared);

// Now do whatever you have to do in the activity
include_once ($source);

// Process comments
if (isset($_REQUEST['__removecomment'])) {
	$__comment = $instance->get_instance_comment($_REQUEST['__removecomment']);

	if ($__comment['username'] == $username or $tiki_p_admin_workflow == 'y') {
		$instance->remove_instance_comment($_REQUEST['__removecomment']);
	}
}

$smarty->assign_by_ref('__comments', $__comments);

if (!isset($_REQUEST['__cid']))
	$_REQUEST['__cid'] = 0;

if (isset($_REQUEST['__post'])) {
	$instance->replace_instance_comment($_REQUEST['__cid'], $activity->getActivityId(), $activity->getName(),
		$username, $_REQUEST['__title'], $_REQUEST['__comment']);
}

$__comments = $instance->get_instance_comments();

// This goes to the end part of all activities
// If this activity is interactive then we have to display the template
if (!isset($_REQUEST['auto']) && $__activity_completed && $activity->isInteractive()) {
	$smarty->assign('procname', $process->getName());
	$smarty->assign('procversion', $process->getVersion());
	$smarty->assign('actname', $activity->getName());
	$smarty->assign('mid', 'tiki-g-activity_completed.tpl');
	$smarty->display("tiki.tpl");
} else {
	if (!isset($_REQUEST['auto']) && $activity->isInteractive()) {
		$section = 'workflow';
		$template = $activity->getNormalizedName(). '.tpl';
		$smarty->assign('mid', $process->getNormalizedName(). '/' . $template);
		$smarty->display("tiki.tpl");
	}
}

?>
